## starpu 1.3.8+dfsg

=== doc/tutorial/Makefile ===
# StarPU --- Runtime system for heterogeneous multicore architectures.
#
# Copyright (C) 2009-2021  Université de Bordeaux, CNRS (LaBRI UMR 5800), Inria
#
# StarPU is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; either version 2.1 of the License, or (at
# your option) any later version.
#
# StarPU is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# See the GNU Lesser General Public License in COPYING.LGPL for more details.
#
CFLAGS          +=      $$(pkg-config --cflags starpu-1.1)
LDLIBS          +=      $$(pkg-config --libs starpu-1.1)

HAS_CUDA	=	$(shell pkg-config --libs starpu-1.1 |grep -i cuda)
NVCC		?=	nvcc
HAS_OPENCL	=	$(shell pkg-config --libs starpu-1.1 |grep -i opencl)

%.o: %.cu
	nvcc $(CFLAGS) $< -c

TARGETS = hello_world vector_scal vector_scal_task_insert

all: $(TARGETS)

VECTOR_SCAL_PREREQUISITES	=	vector_scal.o vector_scal_cpu.o
ifneq ($(strip $(HAS_CUDA)),)
VECTOR_SCAL_PREREQUISITES	+=	vector_scal_cuda.o
VECTOR_SCAL_COMPILER		=	$(NVCC)
else
VECTOR_SCAL_COMPILER		=	$(CC)
endif
ifneq ($(strip $(HAS_OPENCL)),)
VECTOR_SCAL_PREREQUISITES += vector_scal_opencl.o
endif

vector_scal: $(VECTOR_SCAL_PREREQUISITES)
	$(VECTOR_SCAL_COMPILER) $^ $(LDLIBS) -o $@

VECTOR_SCAL_TASK_INSERT_PREREQUISITES		=	vector_scal_task_insert.o vector_scal_cpu.o
ifneq ($(strip $(HAS_CUDA)),)
VECTOR_SCAL_TASK_INSERT_PREREQUISITES		+=	vector_scal_cuda.o
VECTOR_SCAL_TASK_INSERT_COMPILER		=	$(NVCC)
else
VECTOR_SCAL_TASK_INSERT_COMPILER		=	$(CC)
endif
ifneq ($(strip $(HAS_OPENCL)),)
VECTOR_SCAL_TASK_INSERT_PREREQUISITES += vector_scal_opencl.o
endif

vector_scal_task_insert: $(VECTOR_SCAL_TASK_INSERT_PREREQUISITES)
	$(VECTOR_SCAL_TASK_INSERT_COMPILER) $^ $(LDLIBS) -o $@

clean:
	rm -f $(TARGETS) *.o

=== debian/changelog ===
starpu (1.3.8+dfsg-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use versioned copyright format URI.
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Use secure URI in Homepage field.
  * Bump debhelper from old 12 to 13.
  * Remove unused license definitions for GPL-3, QWT.
  * Update standards version to 4.5.1, no changes needed.
  * Remove Section on libstarpu-1.3-7, Section on libstarpufft-1.3-2, Section on
    libstarpumpi-1.3-3, Section on libsocl-1.3-0, Section on libstarpurm-1.3-2
    that duplicate source.

  [ Samuel Thibault ]
  * patches/no_src_build_dir: Really avoid any STARPU_SRC/BUILD_DIR
    definition.

 -- Samuel Thibault <sthibault@debian.org>  Sat, 04 Sep 2021 18:34:24 +0200

starpu (1.3.8+dfsg-2) unstable; urgency=medium

  * Upload to unstable.
  * patches/no_src_dir: Avoid leaking the source directory in installed files.
  * patches/no_src_build_dir: Avoid leaking the source/build directory in
    debugging symbols of installed files.
  * rules: Make sure to undefine STARPU_DEVEL.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 30 Aug 2021 21:51:53 +0200

starpu (1.3.8+dfsg-1) experimental; urgency=medium

  * New upstream release.
    - Rename package libstarpu-1.3-5 to libstarpu-1.3-7 according to soname
    bump.
    - Rename package libstarpurm-1.3-1 to libstarpurm-1.3-2 according to soname
    bump.
    - patches/socl_link: Upstreamed.
    - patches/fortify: Upstreamed.
  * patches/fortify: Fix setting fortify build flag.
  * control: Set Rules-Requires-Root to no.
  * libstarpu-contrib-1.3-5.lintian-overrides: Fix override.
  * watch: Drop gforge URL.
  * gbp.conf: Use filter to clean upstream tarball.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 05 Aug 2021 18:28:45 +0200

=== debian/control ===
Source: starpu
Priority: optional
Maintainer: Samuel Thibault <sthibault@debian.org>
Build-Depends: debhelper-compat (= 13),
	pkg-config,
	libnuma-dev [linux-any],
	libglpk-dev,
	mpi-default-dev,
	libgl1-mesa-dev | libgl-dev,
	libglu1-mesa-dev | libglu-dev,
	freeglut3-dev,
	libx11-dev,
	libblas-dev,
	libfftw3-dev,
	libhwloc-dev,
	libleveldb-dev,
	libhdf5-dev,
	valgrind [amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x powerpc ppc64],
#	guile-2.2,
	opencl-c-headers, ocl-icd-opencl-dev | opencl-dev,
	gfortran,
	help2man, doxygen,
#	nvidia-cuda-toolkit-gcc (>= 10.1),
Rules-Requires-Root: no
Standards-Version: 4.5.1
Section: libs
Homepage: https://starpu.gforge.inria.fr/
Vcs-Git: https://salsa.debian.org/debian/starpu.git
Vcs-Browser: https://salsa.debian.org/debian/starpu

Package: libstarpu-dev
Section: libdevel
Architecture: any
Depends: libstarpu-1.3-7 (= ${binary:Version}) | libstarpu-any-1.3-7, libstarpufft-1.3-2 (= ${binary:Version}) | libstarpu-anyfft-1.3-2, libstarpumpi-1.3-3 (= ${binary:Version}) | libstarpu-anympi-1.3-3, libsocl-1.3-0 (= ${binary:Version}) | libsocl-any-1.3-0, libstarpurm-1.3-2 (= ${binary:Version}) | libstarpu-anyrm-1.3-2, ${misc:Depends}, libhwloc-dev, opencl-headers, ocl-icd-opencl-dev
Conflicts: libstarpu-contrib-dev
Provides: libstarpu-any-dev
Description: Task scheduler for heterogeneous multicore machines - dev
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains development headers and libraries.
# This "contrib" version is built against CUDA.

Package: libstarpu-1.3-7
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libstarpu-contrib-1.3-7
Provides: libstarpu-any-1.3-7
Description: Task scheduler for heterogeneous multicore machines
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains the main StarPU library
# This "contrib" version is built against CUDA.

Package: libstarpufft-1.3-2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libstarpu-contribfft-1.3-2
Provides: libstarpu-anyfft-1.3-2
Description: Task scheduler for heterogeneous multicore machines
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains a hybrid CPU+GPU FFT library.
# This "contrib" version is built against CUDA.

Package: libstarpumpi-1.3-3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libstarpu-contribmpi-1.3-3
Provides: libstarpu-anympi-1.3-3
Description: Task scheduler for heterogeneous multicore machines
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains MPI extensions for StarPU.
# This "contrib" version is built against CUDA.

Package: starpu-tools
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: starpu-contrib-tools
Provides: starpu-any-tools
Recommends: python3
Description: Task scheduler for heterogeneous multicore machines - tools
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains StarPU tools.
# This "contrib" version is built against CUDA.

Package: starpu-examples
Section: science
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: starpu-contrib-examples
Provides: starpu-any-examples
Description: Task scheduler for heterogeneous multicore machines - exs
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains application examples.
# This "contrib" version is built against CUDA.

Package: libsocl-1.3-0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libsocl-contrib-1.3-0
Provides: libsocl-any-1.3-0
Description: Task scheduler for heterogeneous multicore machines
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains an OpenCL-compatible library interface to StarPU.
# This "contrib" version is built against CUDA.

Package: libstarpurm-1.3-2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libstarpu-contribrm-1.3-2
Provides: libstarpu-anyrm-1.3-2
Description: Task scheduler for heterogeneous multicore machines
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains the resource management library.
# This "contrib" version is built against CUDA.

## starpu 1.3.9+dfsg

=== doc/tutorial/Makefile ===
--- 
+++ 
@@ -13,12 +13,12 @@
 #
 # See the GNU Lesser General Public License in COPYING.LGPL for more details.
 #
-CFLAGS          +=      $$(pkg-config --cflags starpu-1.1)
-LDLIBS          +=      $$(pkg-config --libs starpu-1.1)
+CFLAGS          +=      $$(pkg-config --cflags starpu-1.3)
+LDLIBS          +=      $$(pkg-config --libs starpu-1.3)
 
-HAS_CUDA	=	$(shell pkg-config --libs starpu-1.1 |grep -i cuda)
+HAS_CUDA	=	$(shell starpu_machine_display 2>/dev/null | grep CUDA | head -1)
 NVCC		?=	nvcc
-HAS_OPENCL	=	$(shell pkg-config --libs starpu-1.1 |grep -i opencl)
+HAS_OPENCL	=	$(shell starpu_machine_display 2>/dev/null | grep OpenCL | head -1)
 
 %.o: %.cu
 	nvcc $(CFLAGS) $< -c
@@ -35,7 +35,8 @@
 VECTOR_SCAL_COMPILER		=	$(CC)
 endif
 ifneq ($(strip $(HAS_OPENCL)),)
-VECTOR_SCAL_PREREQUISITES += vector_scal_opencl.o
+VECTOR_SCAL_PREREQUISITES 	+=	vector_scal_opencl.o
+LDLIBS				+=	-lOpenCL
 endif
 
 vector_scal: $(VECTOR_SCAL_PREREQUISITES)

=== debian/changelog ===
starpu (1.3.9+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Control: Rename libstarpu-1.3-7 to libstarpu-1.3-8 according to soname
    bump.
    - patches/no_src_build_dir: Upstreamed.
    - patches/no_src_dir: Upstreamed.
    - copyright: Update.
  * control, copyright: Fix upstream URL.
  * control: Make starpu-tools' recommends on python3 :any.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 22 Oct 2021 23:46:27 +0200

=== debian/control ===
--- 
+++ 
@@ -24,14 +24,14 @@
 Rules-Requires-Root: no
 Standards-Version: 4.5.1
 Section: libs
-Homepage: https://starpu.gforge.inria.fr/
+Homepage: https://starpu.gitlabpages.inria.fr/
 Vcs-Git: https://salsa.debian.org/debian/starpu.git
 Vcs-Browser: https://salsa.debian.org/debian/starpu
 
 Package: libstarpu-dev
 Section: libdevel
 Architecture: any
-Depends: libstarpu-1.3-7 (= ${binary:Version}) | libstarpu-any-1.3-7, libstarpufft-1.3-2 (= ${binary:Version}) | libstarpu-anyfft-1.3-2, libstarpumpi-1.3-3 (= ${binary:Version}) | libstarpu-anympi-1.3-3, libsocl-1.3-0 (= ${binary:Version}) | libsocl-any-1.3-0, libstarpurm-1.3-2 (= ${binary:Version}) | libstarpu-anyrm-1.3-2, ${misc:Depends}, libhwloc-dev, opencl-headers, ocl-icd-opencl-dev
+Depends: libstarpu-1.3-8 (= ${binary:Version}) | libstarpu-any-1.3-8, libstarpufft-1.3-2 (= ${binary:Version}) | libstarpu-anyfft-1.3-2, libstarpumpi-1.3-3 (= ${binary:Version}) | libstarpu-anympi-1.3-3, libsocl-1.3-0 (= ${binary:Version}) | libsocl-any-1.3-0, libstarpurm-1.3-2 (= ${binary:Version}) | libstarpu-anyrm-1.3-2, ${misc:Depends}, libhwloc-dev, opencl-headers, ocl-icd-opencl-dev
 Conflicts: libstarpu-contrib-dev
 Provides: libstarpu-any-dev
 Description: Task scheduler for heterogeneous multicore machines - dev
@@ -46,12 +46,12 @@
  This package contains development headers and libraries.
 # This "contrib" version is built against CUDA.
 
-Package: libstarpu-1.3-7
+Package: libstarpu-1.3-8
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpu-contrib-1.3-7
-Provides: libstarpu-any-1.3-7
+Conflicts: libstarpu-contrib-1.3-8
+Provides: libstarpu-any-1.3-8
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -106,7 +106,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: starpu-contrib-tools
 Provides: starpu-any-tools
-Recommends: python3
+Recommends: python3:any
 Description: Task scheduler for heterogeneous multicore machines - tools
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d*$//,uversionmangle=s/(\d)(rc\d*)$/$1~$2/ \
https://files.inria.fr/starpu/ \
(?:|.*/)starpu(?:[_\-]v?|)@ANY_VERSION@@ARCHIVE_EXT@

## starpu 1.3.10+dfsg

=== min-dgels/Makefile ===
CC = gcc
LD = /usr/bin/ld -m elf_x86_64
srcdir = .

CLAPACK=base
ADDITIONAL=additional

all:
	mkdir -p build
	[ -d "$(CLAPACK)" ] || ( cp -a $(srcdir)/$(CLAPACK) . ; chmod -R +rwX $(CLAPACK) )
	cd $(CLAPACK) && $(MAKE) blaslib CC="$(CC)" LD="$(LD)"
	cd $(CLAPACK) && $(MAKE) f2clib CC="$(CC)" LD="$(LD)"
	[ -d "$(ADDITIONAL)" ] || ( cp -a $(srcdir)/$(ADDITIONAL) . ; chmod -R +rwX $(ADDITIONAL) )
	cd $(ADDITIONAL) && $(CC) -c -fPIC *.c && ar cr ../build/minlibdgels.a *.o && ranlib ../build/minlibdgels.a

install:
installcheck:
uninstall:
distuninstallcheck:
dvi:

clean:
	-cd $(CLAPACK) && $(MAKE) clean && rm -rf *~
	-cd $(ADDITIONAL) && rm -rf *.o *~
	rm -rf build *~

distclean: clean
	[ -f Makefile.in ] || rm -fr $(CLAPACK) $(ADDITIONAL)

# This part is needed by StarPU

STARPU_SRCDIR = .

distdir:
	cp -fRp $(STARPU_SRCDIR)/* $(distdir)
	cd $(distdir) && make -f Makefile.in clean

check:
	echo "No checks are implemented for min-dgels"
recheck:
	echo "No checks are implemented for min-dgels"

showfailed:
	@:

showcheck: check

showsuite: check

=== debian/changelog ===
starpu (1.3.10+dfsg-2) unstable; urgency=medium

  * Rebuild on buildd.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 17 Nov 2022 00:05:44 +0100

starpu (1.3.10+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - control: Rename libstarpu-1.3-8 to libstarpu-1.3-9 according to soname
    bump.
  * control: Bump Standards-Version to 4.6.0 (no change)
  * control: Use valgrind-if-available instead of hardcoding a list.
  * rules: Leverage /usr/share/dpkg/pkg-info.mk to provide package
    information.
  * control: Make Multi-Arch: foreign.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 16 Nov 2022 10:10:05 +0100

=== debian/control ===
--- 
+++ 
@@ -15,14 +15,14 @@
 	libhwloc-dev,
 	libleveldb-dev,
 	libhdf5-dev,
-	valgrind [amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x powerpc ppc64],
+	valgrind-if-available,
 #	guile-2.2,
 	opencl-c-headers, ocl-icd-opencl-dev | opencl-dev,
 	gfortran,
 	help2man, doxygen,
 #	nvidia-cuda-toolkit-gcc (>= 10.1),
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Section: libs
 Homepage: https://starpu.gitlabpages.inria.fr/
 Vcs-Git: https://salsa.debian.org/debian/starpu.git
@@ -31,7 +31,7 @@
 Package: libstarpu-dev
 Section: libdevel
 Architecture: any
-Depends: libstarpu-1.3-8 (= ${binary:Version}) | libstarpu-any-1.3-8, libstarpufft-1.3-2 (= ${binary:Version}) | libstarpu-anyfft-1.3-2, libstarpumpi-1.3-3 (= ${binary:Version}) | libstarpu-anympi-1.3-3, libsocl-1.3-0 (= ${binary:Version}) | libsocl-any-1.3-0, libstarpurm-1.3-2 (= ${binary:Version}) | libstarpu-anyrm-1.3-2, ${misc:Depends}, libhwloc-dev, opencl-headers, ocl-icd-opencl-dev
+Depends: libstarpu-1.3-9 (= ${binary:Version}) | libstarpu-any-1.3-9, libstarpufft-1.3-2 (= ${binary:Version}) | libstarpu-anyfft-1.3-2, libstarpumpi-1.3-3 (= ${binary:Version}) | libstarpu-anympi-1.3-3, libsocl-1.3-0 (= ${binary:Version}) | libsocl-any-1.3-0, libstarpurm-1.3-2 (= ${binary:Version}) | libstarpu-anyrm-1.3-2, ${misc:Depends}, libhwloc-dev, opencl-headers, ocl-icd-opencl-dev
 Conflicts: libstarpu-contrib-dev
 Provides: libstarpu-any-dev
 Description: Task scheduler for heterogeneous multicore machines - dev
@@ -46,12 +46,12 @@
  This package contains development headers and libraries.
 # This "contrib" version is built against CUDA.
 
-Package: libstarpu-1.3-8
+Package: libstarpu-1.3-9
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpu-contrib-1.3-8
-Provides: libstarpu-any-1.3-8
+Conflicts: libstarpu-contrib-1.3-9
+Provides: libstarpu-any-1.3-9
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -103,6 +103,7 @@
 Package: starpu-tools
 Section: utils
 Architecture: any
+Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: starpu-contrib-tools
 Provides: starpu-any-tools

## starpu 1.4.1+dfsg

=== debian/changelog ===
starpu (1.4.1+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 11 Jun 2023 14:00:04 +0200

starpu (1.4.1+dfsg-1) experimental; urgency=medium

  * New upstream release.
    - Rename library packages according to soname bumps.
    - Closes: Bug#1036683.
    - patches/atomic: Upstreamed.
    - patches/atomic2: Upstreamed.
    - patches/atomic3: Upstreamed.
    - patches/hurd_max: Upstreamed.
    - patches/llvm-openmp: Upstreamed.
    - patches/openmp_llvm_variant: Upstreamed.
    - patches/socl-atomic: Upstreamed.
    - patches/starpurm-hwloc: Upstreamed.
    - patches/tasks_size_overhead_cpustep: Upstreamed.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 24 May 2023 18:18:07 +0200

starpu (1.4.0+dfsg-4) experimental; urgency=medium

  * control: Don't build-dep on clang on archs which don't have libomp-dev.
  * libstarpu-openmp-llvm-1.4-1: Don't build package on archs which don't have
    libomp-dev.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 09 Apr 2023 11:09:10 +0200

starpu (1.4.0+dfsg-3) experimental; urgency=medium

  * patches/hurd_max: Fix build issue.
  * control: Restraint libpapi-dev build-dep on archs where it actually
    builds. Add pajeng build-dep.
  * rules: Do not call chrpath on archs where openmp-llvm is not available.
  * patches/socl-atomic: Make socl use starpu macros for atomic operations.
  * patches/atomic, atomic2, atomic3: Fix 64bit atomics on some 32bit archs.

 -- Samuel Thibault <sthibault@debian.org>  Sat, 08 Apr 2023 18:42:10 +0200

starpu (1.4.0+dfsg-2) experimental; urgency=medium

  * rules: Fix multiarch path.
  * control: Build-dep on libpapi-dev on linux-any only.
  * control, rules: Enable openmp-llvm on archs that have libomp-dev only.
  * patches/openmp_llvm_variant: Fix LLVM-based openmp support.
  * tests/examples: Avoid running meant-to-deadlock test.
  * patches/tasks_size_overhead_cpustep: Fix autopkgtest hanging.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 04 Apr 2023 17:53:33 +0200

starpu (1.4.0+dfsg-1) experimental; urgency=medium

  * New upstream release.
    - Rename packages according to soname bump.
    - New libstarpu-openmp-llvm-1.4-1 package for new library.
    - control: Complete migration from libgl1-mesa-dev to libgl-dev and from
    libglu1-mesa-dev to libglu-dev.
    - control: Add chrpath, libfxt-dev, libpapi-dev, python3-all-dev,
    libpython3-all-dev, python3-joblib, clang, libomp-dev build-deps.
    - rules: --enable-tcpip-master-slave, --enable-openmp-llvm.
    - docs: README was renamed to README.md
    - libstarpu-1.3-9.install: Install loadable libraries.
    - not-installed: Do not install the starpu module, starpu_config.cfg, and
    .a/.la libs.
    - patches/llvm-openmp: Fix llvm-openmp build.
    - patches/starpurm-hwloc: Add missing link against hwloc.
    - rules: drop rpath from llvm OMP examples.
    - gbp.conf: Update filter.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 29 Mar 2023 11:33:08 +0200

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,13 @@
 Priority: optional
 Maintainer: Samuel Thibault <sthibault@debian.org>
 Build-Depends: debhelper-compat (= 13),
+	chrpath,
 	pkg-config,
 	libnuma-dev [linux-any],
 	libglpk-dev,
 	mpi-default-dev,
-	libgl1-mesa-dev | libgl-dev,
-	libglu1-mesa-dev | libglu-dev,
+	libgl-dev,
+	libglu-dev,
 	freeglut3-dev,
 	libx11-dev,
 	libblas-dev,
@@ -15,6 +16,12 @@
 	libhwloc-dev,
 	libleveldb-dev,
 	libhdf5-dev,
+	libfxt-dev, pajeng,
+	libpapi-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el hppa ppc64 x32],
+	python3-dev,
+	libpython3-dev, python3-joblib,
+	clang      [amd64 arm64 armhf i386 mips64el ppc64el ppc64 riscv64],
+	libomp-dev [amd64 arm64 armhf i386 mips64el ppc64el ppc64 riscv64],
 	valgrind-if-available,
 #	guile-2.2,
 	opencl-c-headers, ocl-icd-opencl-dev | opencl-dev,
@@ -31,7 +38,7 @@
 Package: libstarpu-dev
 Section: libdevel
 Architecture: any
-Depends: libstarpu-1.3-9 (= ${binary:Version}) | libstarpu-any-1.3-9, libstarpufft-1.3-2 (= ${binary:Version}) | libstarpu-anyfft-1.3-2, libstarpumpi-1.3-3 (= ${binary:Version}) | libstarpu-anympi-1.3-3, libsocl-1.3-0 (= ${binary:Version}) | libsocl-any-1.3-0, libstarpurm-1.3-2 (= ${binary:Version}) | libstarpu-anyrm-1.3-2, ${misc:Depends}, libhwloc-dev, opencl-headers, ocl-icd-opencl-dev
+Depends: libstarpu-1.4-2 (= ${binary:Version}) | libstarpu-any-1.4-2, libstarpu-openmp-llvm-1.4-1 (= ${binary:Version}) | libstarpu-any-openmp-llvm-1.4-1, libstarpufft-1.4-1 (= ${binary:Version}) | libstarpu-anyfft-1.4-1, libstarpumpi-1.4-2 (= ${binary:Version}) | libstarpu-anympi-1.4-2, libsocl-1.4-1 (= ${binary:Version}) | libsocl-any-1.4-1, libstarpurm-1.4-1 (= ${binary:Version}) | libstarpu-anyrm-1.4-1, ${misc:Depends}, libhwloc-dev, opencl-headers, ocl-icd-opencl-dev
 Conflicts: libstarpu-contrib-dev
 Provides: libstarpu-any-dev
 Description: Task scheduler for heterogeneous multicore machines - dev
@@ -46,12 +53,12 @@
  This package contains development headers and libraries.
 # This "contrib" version is built against CUDA.
 
-Package: libstarpu-1.3-9
-Architecture: any
-Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpu-contrib-1.3-9
-Provides: libstarpu-any-1.3-9
+Package: libstarpu-1.4-2
+Architecture: any
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libstarpu-contrib-1.4-2
+Provides: libstarpu-any-1.4-2
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -64,12 +71,30 @@
  This package contains the main StarPU library
 # This "contrib" version is built against CUDA.
 
-Package: libstarpufft-1.3-2
-Architecture: any
-Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpu-contribfft-1.3-2
-Provides: libstarpu-anyfft-1.3-2
+Package: libstarpu-openmp-llvm-1.4-1
+Architecture: amd64 arm64 armhf i386 mips64el ppc64el ppc64 riscv64
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libstarpu-contrib-openmp-llvm-1.4-1
+Provides: libstarpu-any-openmp-llvm-1.4-1
+Description: Task scheduler for heterogeneous multicore machines
+ StarPU is a runtime system that offers support for heterogeneous
+ multicore machines. While many efforts are devoted to design efficient
+ computation kernels for those architectures (e.g. to implement BLAS
+ kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
+ offloading such kernels (and implementing data coherency across
+ the machine), but it also makes sure the kernels are executed as
+ efficiently as possible.
+ .
+ This package contains the runtime support for LLVM OpenMP.
+# This "contrib" version is built against CUDA.
+
+Package: libstarpufft-1.4-1
+Architecture: any
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libstarpu-contribfft-1.4-1
+Provides: libstarpu-anyfft-1.4-1
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -82,12 +107,12 @@
  This package contains a hybrid CPU+GPU FFT library.
 # This "contrib" version is built against CUDA.
 
-Package: libstarpumpi-1.3-3
-Architecture: any
-Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpu-contribmpi-1.3-3
-Provides: libstarpu-anympi-1.3-3
+Package: libstarpumpi-1.4-2
+Architecture: any
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libstarpu-contribmpi-1.4-2
+Provides: libstarpu-anympi-1.4-2
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -139,12 +164,12 @@
  This package contains application examples.
 # This "contrib" version is built against CUDA.
 
-Package: libsocl-1.3-0
-Architecture: any
-Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libsocl-contrib-1.3-0
-Provides: libsocl-any-1.3-0
+Package: libsocl-1.4-1
+Architecture: any
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libsocl-contrib-1.4-1
+Provides: libsocl-any-1.4-1
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -157,12 +182,12 @@
  This package contains an OpenCL-compatible library interface to StarPU.
 # This "contrib" version is built against CUDA.
 
-Package: libstarpurm-1.3-2
-Architecture: any
-Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpu-contribrm-1.3-2
-Provides: libstarpu-anyrm-1.3-2
+Package: libstarpurm-1.4-1
+Architecture: any
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libstarpu-contribrm-1.4-1
+Provides: libstarpu-anyrm-1.4-1
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient

=== debian/rules ===
#!/usr/bin/make -f

# This may bring unexpected warnings/errors
undefine STARPU_DEVEL

DH_OPTIONS=-Bbuild

# These are the best versions that nvcc supports.
CONTRIB_GCC_VERSION  := 8
CONTRIB_CLANG_VERSION  := 8

ifeq ($(DEB_SOURCE),starpu-contrib)
# nvcc sometimes chokes on some gcc features
CC=cuda-gcc
CXX=cuda-g++
endif
OMPI_CC=$(CC)
export CC
export CXX
export OMPI_CC

export NVCCFLAGS = -Xcompiler -fPIC -Xcompiler -std=c++03

ifneq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
CONFIGURE_NODOC = --disable-build-doc
endif

ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 mips64el ppc64el ppc64 riscv64))
OPENMP_LLVM=1
else
OPENMP_LLVM=0
endif

ifeq ($(OPENMP_LLVM),1)
CONFIGURE_OPENMP_LLVM = --enable-openmp-llvm
endif

%:
	dh $@ $(DH_OPTIONS)

override_dh_auto_configure:
	dh_auto_configure $(DH_OPTIONS) -- \
		--enable-opengl-render \
		--enable-openmp \
		--enable-quick-check \
		--enable-mlr-system-blas \
		--enable-starpurm \
		--enable-starpurm-examples \
		--enable-tcpip-master-slave \
		--docdir=/usr/share/doc/libstarpu-dev --disable-build-doc-pdf \
		$(CONFIGURE_OPENMP_LLVM) \
		$(CONFIGURE_NODOC)

override_dh_auto_test:
	-HOME=$$PWD DISPLAY= DEB_BUILD_OPTIONS=$(patsubst parallel=%,,$(DEB_BUILD_OPTIONS)) dh_auto_test $(DH_OPTIONS) -- -k
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C build showcheck
endif

override_dh_auto_install:
	dh_auto_install
ifeq ($(OPENMP_LLVM),1)
	# Debian does symlink libomp into libdir
	chrpath -d $(CURDIR)/debian/tmp/usr/lib/*/starpu/examples/starpu_openmp_llvm/hello-task
endif

override_dh_auto_clean:
	# No idea why salsa CI is adding +x on libsocl-1.3-0.install and libstarpu-1.3-5.install (and no others...)
	ls -l debian/*.install
	chmod -x debian/*.install
	dh_auto_clean $(DH_OPTIONS)
	rm -fr doc/doxygen/starpu.pdf
	rm -fr doc/doxygen/html
	rm -fr .starpu
	rm -fr .nv

# Switch to main rules
sw-main:
	sed -i 's/^starpu-contrib /starpu /' debian/changelog
	sed -i '1s/^Source: starpu-contrib/Source: starpu/' debian/control
	sed -i 's/Package: libstarpu-contrib/Package: libstarpu/' debian/control
	sed -i 's/Package: starpu-contrib/Package: starpu/' debian/control
	sed -i 's/Package: libsocl-contrib/Package: libsocl/' debian/control
	sed -i '/Depends/s/ libstarpu-contrib/ libstarpu/g' debian/control
	sed -i '/Depends/s/ libsocl-contrib/ libsocl/g' debian/control
	sed -i 's/Conflicts: libstarpu/Conflicts: libstarpu-contrib/' debian/control
	sed -i 's/Conflicts: libsocl/Conflicts: libsocl-contrib/' debian/control
	sed -i 's/Conflicts: starpu/Conflicts: starpu-contrib/' debian/control
	sed -i 's/^	nvidia-cuda-toolkit-gcc/#	nvidia-cuda-toolkit-gcc/' debian/control
	sed -i 's_^Section: contrib/_Section: _' debian/control
	sed -i 's/contrib-contrib/contrib/g' debian/control debian/changelog
	sed -i 's/^ This "contrib" version/# This "contrib" version/' debian/control

# Switch to contrib rules
sw-contrib:
	sed -i 's/^starpu /starpu-contrib /' debian/changelog
	sed -i '1s/^Source: starpu/Source: starpu-contrib/' debian/control
	sed -i 's/Package: libstarpu/Package: libstarpu-contrib/' debian/control
	sed -i 's/Package: starpu/Package: starpu-contrib/' debian/control
	sed -i 's/Package: libsocl/Package: libsocl-contrib/' debian/control
	sed -i '/Depends/s/ libstarpu/ libstarpu-contrib/g' debian/control
	sed -i '/Depends/s/ libsocl/ libsocl-contrib/g' debian/control
	sed -i 's/Conflicts: libstarpu-contrib/Conflicts: libstarpu/' debian/control
	sed -i 's/Conflicts: libsocl-contrib/Conflicts: libsocl/' debian/control
	sed -i 's/Conflicts: starpu-contrib/Conflicts: starpu/' debian/control
	sed -i 's/#	nvidia-cuda-toolkit-gcc/	nvidia-cuda-toolkit-gcc/' debian/control
	sed -i 's_contrib/contrib/_contrib_g' debian/control debian/control
	sed -i 's/contrib-contrib/contrib/g' debian/control debian/changelog
	sed -i 's_^Section: \([^/]*\)$$_Section: contrib/\1_' debian/control
	sed -i 's/^# This "contrib" version/ This "contrib" version/' debian/control

## starpu 1.4.2+dfsg

=== debian/changelog ===
starpu (1.4.2+dfsg-2) unstable; urgency=medium

  * Move libdummy_sched, libmy_dmda and libprofiling_tool into starpu-examples,
    to allow different libstarpu versions be co-installable.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 24 Nov 2023 12:03:52 +0100

starpu (1.4.2+dfsg-1) experimental; urgency=medium

  * New upstream release.
    - Rename libstarpu-1.4-2 and libstarpumpi-1.4-2 according to soname bump.
    - patches/parallel_workers: Upstreamed.
    - patches/eztrace: Upstreamed.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 24 Nov 2023 10:07:57 +0100

starpu (1.4.1+dfsg-8) unstable; urgency=medium

  * control: Make libstarpu-dev dep on libpapi-dev only where needed.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 29 Aug 2023 11:43:40 +0200

starpu (1.4.1+dfsg-7) unstable; urgency=medium

  * patches/eztrace: Let eztrace trace job start/end.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 28 Aug 2023 11:56:08 +0200

starpu (1.4.1+dfsg-6) unstable; urgency=medium

  * control: Make libstarpu-dev dep on libpapi-dev.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 25 Aug 2023 18:49:15 +0200

starpu (1.4.1+dfsg-5) unstable; urgency=medium

  * patches/parallel_workers: Fix parallel_workers test on machines with a lot
    of CPU sockets.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 07 Aug 2023 21:43:52 +0200

starpu (1.4.1+dfsg-4) unstable; urgency=medium

  * rules: Also hardcode the maximum number of cpus and NUMA nodes.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 14 Jul 2023 16:07:57 +0200

starpu (1.4.1+dfsg-3) unstable; urgency=medium

  * control: Make libstarpu depend on libstarpu-openmp-llvm only on archs
    which have it built.
  * rules: Hardcode the maximum number of nodes.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 13 Jul 2023 12:34:11 +0200

=== debian/control ===
--- 
+++ 
@@ -38,7 +38,7 @@
 Package: libstarpu-dev
 Section: libdevel
 Architecture: any
-Depends: libstarpu-1.4-2 (= ${binary:Version}) | libstarpu-any-1.4-2, libstarpu-openmp-llvm-1.4-1 (= ${binary:Version}) | libstarpu-any-openmp-llvm-1.4-1, libstarpufft-1.4-1 (= ${binary:Version}) | libstarpu-anyfft-1.4-1, libstarpumpi-1.4-2 (= ${binary:Version}) | libstarpu-anympi-1.4-2, libsocl-1.4-1 (= ${binary:Version}) | libsocl-any-1.4-1, libstarpurm-1.4-1 (= ${binary:Version}) | libstarpu-anyrm-1.4-1, ${misc:Depends}, libhwloc-dev, opencl-headers, ocl-icd-opencl-dev
+Depends: libstarpu-1.4-3 (= ${binary:Version}) | libstarpu-any-1.4-3, libstarpu-openmp-llvm-1.4-1 (= ${binary:Version}) [amd64 arm64 armhf i386 mips64el ppc64el ppc64 riscv64] | libstarpu-any-openmp-llvm-1.4-1 [amd64 arm64 armhf i386 mips64el ppc64el ppc64 riscv64], libstarpufft-1.4-1 (= ${binary:Version}) | libstarpu-anyfft-1.4-1, libstarpumpi-1.4-3 (= ${binary:Version}) | libstarpu-anympi-1.4-3, libsocl-1.4-1 (= ${binary:Version}) | libsocl-any-1.4-1, libstarpurm-1.4-1 (= ${binary:Version}) | libstarpu-anyrm-1.4-1, ${misc:Depends}, libhwloc-dev, opencl-headers, ocl-icd-opencl-dev, libpapi-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el hppa ppc64 x32]
 Conflicts: libstarpu-contrib-dev
 Provides: libstarpu-any-dev
 Description: Task scheduler for heterogeneous multicore machines - dev
@@ -53,12 +53,12 @@
  This package contains development headers and libraries.
 # This "contrib" version is built against CUDA.
 
-Package: libstarpu-1.4-2
-Architecture: any
-Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpu-contrib-1.4-2
-Provides: libstarpu-any-1.4-2
+Package: libstarpu-1.4-3
+Architecture: any
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libstarpu-contrib-1.4-3
+Provides: libstarpu-any-1.4-3
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -107,12 +107,12 @@
  This package contains a hybrid CPU+GPU FFT library.
 # This "contrib" version is built against CUDA.
 
-Package: libstarpumpi-1.4-2
-Architecture: any
-Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpu-contribmpi-1.4-2
-Provides: libstarpu-anympi-1.4-2
+Package: libstarpumpi-1.4-3
+Architecture: any
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libstarpu-contribmpi-1.4-3
+Provides: libstarpu-anympi-1.4-3
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -150,6 +150,8 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Breaks: libstarpu-1.4-1, libstarpu-contrib-1.4-1, libstarpu-1.4-2, libstarpu-contrib-1.4-2
+Replaces: libstarpu-1.4-1, libstarpu-contrib-1.4-1, libstarpu-1.4-2, libstarpu-contrib-1.4-2
 Conflicts: starpu-contrib-examples
 Provides: starpu-any-examples
 Description: Task scheduler for heterogeneous multicore machines - exs

=== debian/rules ===
--- 
+++ 
@@ -46,6 +46,9 @@
 		--enable-mlr-system-blas \
 		--enable-starpurm \
 		--enable-starpurm-examples \
+		--enable-maxnodes=16 \
+		--enable-maxcpus=32 \
+		--enable-maxnumanodes=4 \
 		--enable-tcpip-master-slave \
 		--docdir=/usr/share/doc/libstarpu-dev --disable-build-doc-pdf \
 		$(CONFIGURE_OPENMP_LLVM) \

## starpu 1.4.3%2Bdfsg

=== tools/release/Makefile ===
# StarPU --- Runtime system for heterogeneous multicore architectures.
#
# Copyright (C) 2009-2023  Université de Bordeaux, CNRS (LaBRI UMR 5800), Inria
#
# StarPU is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; either version 2.1 of the License, or (at
# your option) any later version.
#
# StarPU is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# See the GNU Lesser General Public License in COPYING.LGPL for more details.
#
STARPU		?=	undefined
EXAMPLE		?= 	undefined

TARGETS		=
TARGETS		+=	hello_world
TARGETS 	+=	block
TARGETS		+=	mult
TARGETS		+=	variable
TARGETS		+=	incrementer

ifeq ($(STARPU),undefined)
all:
	@echo
	@echo "ERROR. You need to set the variable STARPU to the name of the pkg-config StarPU package"
	@echo
clean:; rm -f $(TARGETS) *.o

else
ifeq ($(EXAMPLE),undefined)
all:
	@echo
	@echo "ERROR. You need to set the variable EXAMPLE to the directory hosting the example sources"
	@echo
clean:; rm -f $(TARGETS) *.o

else

CFLAGS          +=      $$(pkg-config --cflags $(STARPU))
LDFLAGS         +=      $$(pkg-config --libs $(STARPU))

HAS_CUDA	=	$(shell starpu_config -d | grep -c STARPU_USE_CUDA)
NVCC		?=	nvcc
HAS_OPENCL	=	$(shell starpu_config -d | grep -c STARPU_USE_OPENCL)

ifneq ($(strip $(HAS_CUDA)),0)
LDFLAGS		+=	-lcudart
endif

ifneq ($(strip $(HAS_OPENCL)),0)
LDFLAGS		+=	-lOpenCL
endif

%: %.o
	$(CC) $< $(LDFLAGS) -o $@
%.o: $(EXAMPLE)/basic_examples/%.cu
	$(NVCC) -std=c++11 $(CFLAGS) $< -c
%.o: $(EXAMPLE)/basic_examples/%.c
	$(CC) $(CFLAGS) $< -c

%.o: $(EXAMPLE)/incrementer/%.cu
	$(NVCC) -std=c++11 $(CFLAGS) $< -c
%.o: $(EXAMPLE)/incrementer/%.c
	$(CC) $(CFLAGS) $< -c

all: $(TARGETS)

BLOCK_PREREQUISITES	=	block.o block_cpu.o
ifneq ($(strip $(HAS_CUDA)),0)
BLOCK_PREREQUISITES	+=	block_cuda.o
endif
ifneq ($(strip $(HAS_OPENCL)),0)
BLOCK_PREREQUISITES    +=	block_opencl.o
endif
block: $(BLOCK_PREREQUISITES)
	$(CC) $^ $(LDFLAGS) -o $@

VARIABLE_PREREQUISITES	=	variable.o variable_kernels_cpu.o
ifneq ($(strip $(HAS_CUDA)),)
VARIABLE_PREREQUISITES	+=	variable_kernels.o
endif
ifneq ($(strip $(HAS_OPENCL)),)
VARIABLE_PREREQUISITES    +=	variable_kernels_opencl.o
endif
variable: $(VARIABLE_PREREQUISITES)
	$(CC) $^ $(LDFLAGS) -o $@

INCREMENTER_PREREQUISITES	=	incrementer.o
ifneq ($(strip $(HAS_CUDA)),)
INCREMENTER_PREREQUISITES	+=	incrementer_kernels.o
endif
ifneq ($(strip $(HAS_OPENCL)),)
INCREMENTER_PREREQUISITES    +=	incrementer_kernels_opencl.o
endif
incrementer: $(INCREMENTER_PREREQUISITES)
	$(CC) $^ $(LDFLAGS) -o $@

MULT_PREREQUISITES	=	mult.o
ifneq ($(strip $(HAS_CUDA)),0)
MULT_PREREQUISITES	+=	mult_cuda.o
endif
mult: $(MULT_PREREQUISITES)
	$(CC) $^ $(LDFLAGS) -o $@

clean:; rm -f $(TARGETS) *.o


endif
endif
